﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.Core;


namespace CustomZoomLevelSet
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
            Map1.CurrentExtent = new RectangleShape(-140, 60, 140, -60);
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(MapPath("~/App_Data/cntry02.shp"));

            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(1000000000, GeoColor.SimpleColors.Red));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(500000000, GeoColor.SimpleColors.Yellow));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(250000000, GeoColor.SimpleColors.Green));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(125000000, GeoColor.SimpleColors.Blue));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(62500000, GeoColor.SimpleColors.Orange));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(31250000, GeoColor.SimpleColors.Silver));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(15625000, GeoColor.SimpleColors.Black));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(7812500, GeoColor.SimpleColors.Gold));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(3906250, GeoColor.SimpleColors.Copper));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(2953125, GeoColor.SimpleColors.LightRed));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(1500000, GeoColor.SimpleColors.LightYellow));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(750000, GeoColor.SimpleColors.LightBlue));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(375000, GeoColor.SimpleColors.LightOrange));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(50000, GeoColor.SimpleColors.PaleBlue));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(20000, GeoColor.SimpleColors.PaleGreen));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(10000, GeoColor.SimpleColors.PaleOrange));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(5000, GeoColor.SimpleColors.PaleYellow));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(1000, GeoColor.SimpleColors.LightBlue));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(100, GeoColor.SimpleColors.LightGreen));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(10, GeoColor.SimpleColors.LightOrange));
            worldLayer.ZoomLevelSet.CustomZoomLevels.Add(GetZoomLevel(1, GeoColor.SimpleColors.LightRed));

            // The following code, 
            // 1, Has a limitation that we only has 1~20 ZoomLevels
            // 2, Has a bug that even I set the ApplyUntilZoomLevel to Level20, it will not apply to Level20 in fact
            // worldLayer.ZoomLevelSet.CustomZoomLevels[0].ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            Map1.StaticOverlay.Layers.Add(worldLayer);

            Map1.SyncClientZoomLevels(worldLayer.ZoomLevelSet);
        }


        private ZoomLevel GetZoomLevel(double scale, GeoColor geoColor)
        {
            ZoomLevel zoomLevel = new ZoomLevel(scale);
            zoomLevel.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(geoColor);
            return zoomLevel;
        }
    }
}
